import 'package:flutter/material.dart';
import 'package:json_annotation/json_annotation.dart';
import 'package:ocg_app/ocg_app.dart';

part 'client.g.dart';

@JsonSerializable(explicitToJson: true)
class PaymentClient {
  final String id;
  final String title;
  final String icon;
  final String category;
  @JsonKey(toJson: JsonHelper.colorToJson, fromJson: JsonHelper.colorFromJson)
  final Color color;

  PaymentClient(this.id, this.title, this.icon, this.category, this.color);

  PaymentClient.named(
      {this.id, this.title, this.icon, this.category, this.color});

  Map<String, dynamic> toJson() => _$PaymentClientToJson(this);

  factory PaymentClient.fromJson(json) => _$PaymentClientFromJson(json);
}
