import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_payment/ocg_payment.dart';
import 'package:ocg_payment/src/modals/amount.dart';
import 'package:ocg_payment/src/modals/balance.dart';
import 'package:ocg_payment/src/modals/method.dart';
import 'package:ocg_payment/src/modals/request.dart';
import 'package:ocg_payment/src/modals/response.dart';

abstract class PaymentRepository {
  Future<AppResponse<PaymentResponse>> payAmount(PaymentRequest request);
  Future<AppResponse<bool>> addAmount(Amount amount);
  Future<AppResponse<List<PaymentMethod>>> getMethods();
  Future<AppResponse<String>> addMethod(PaymentMethod method);
  Future<AppResponse<PaymentBalance>> getBalance();
  Future<AppResponse<List<PaymentBalance>>> getMultipleBalances() {
    throw UnimplementedError();
  }

  Future<AppResponse<List<PaymentTransaction>>> getTransactions();
  Future<String> getCurrency();
}
