import 'package:flutter/material.dart';
import 'package:ocg_payment/src/metadata/colors.dart';

class PrimaryButton extends StatelessWidget {
  final String label;
  final Color color;
  final Function() onPressed;
  const PrimaryButton({Key key, this.color, this.label, this.onPressed})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return LayoutBuilder(builder: (context, contraints) {
      double width = contraints.biggest.width;
      return SizedBox(
        width: width,
        child: RaisedButton(
          color: color ?? MetaColors.logoColor,
          padding: EdgeInsets.symmetric(vertical: 12),
          shape: RoundedRectangleBorder(borderRadius: BorderRadius.circular(6)),
          child: Text(
            "$label",
            style: TextStyle(
                color: Colors.white, fontSize: 18, fontWeight: FontWeight.w500),
          ),
          onPressed: onPressed,
        ),
      );
    });
  }
}
