import 'package:flutter/material.dart';
import 'package:ocg_app/ocg_app.dart';
import 'package:ocg_payment/src/modals/method.dart';

class WalletWidget extends StatelessWidget {
  final Function(bool isSelected, PaymentWallet wallet) onPressed;
  final PaymentWallet wallet;
  final bool isSelected;

  const WalletWidget(
      {Key key, @required this.wallet, this.onPressed, this.isSelected = false})
      : super(key: key);
  @override
  Widget build(BuildContext context) {
    return EaseInWidget(
      onTap: onPressed != null ? () => onPressed(!isSelected, wallet) : null,
      child: Container(
        width: 110,
        child: Stack(
          children: [
            Container(
              width: 110,
              padding: EdgeInsets.all(12),
              decoration: BoxDecoration(
                  color: isSelected ? Colors.white : Color(0xffeeeeee),
                  borderRadius: BorderRadius.circular(12)),
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: <Widget>[
                  Container(
                    width: 36,
                    height: 36,
                    decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(4),
                        image: DecorationImage(
                            image: NetworkImage(
                              "${wallet.logo}",
                            ),
                            fit: BoxFit.fill)),
                  ),
                  SizedBox(
                    height: 12,
                  ),
                  Text(
                    "${wallet.name}",
                    style: TextStyle(
                        color: Colors.black,
                        fontSize: 14,
                        fontWeight: FontWeight.w600),
                  ),
                  SizedBox(
                    height: 2,
                  ),
                  Text(
                    "${wallet.amount} ${wallet.currency}",
                    style: TextStyle(color: Colors.black38, fontSize: 13),
                  ),
                ],
              ),
            ),
            isSelected
                ? Align(
                    alignment: Alignment.topRight,
                    child: Padding(
                      padding: const EdgeInsets.all(8.0),
                      child: Icon(
                        Icons.check_circle,
                        color: Colors.green,
                      ),
                    ),
                  )
                : Container(
                    width: 0,
                    height: 0,
                  )
          ],
        ),
      ),
    );
  }
}
